#include <bits/stdc++.h>
using namespace std;


const long long MAXN = 2e5 + 10;
vector <tuple <long long, long long, long long>> edges[MAXN];
long long n, m;

long long t[MAXN], p[MAXN];
bool v[MAXN];

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (long long i = 1; i <= m; i++) {
        long long u, v, p, t;
        cin >> u >> v >> p >> t;


        edges[u].push_back({p, t, v});
        edges[v].push_back({p, t, u});
    }

    fill(t, t + MAXN, LLONG_MAX);
    priority_queue <tuple <long long, long long, long long>, vector <tuple <long long, long long, long long>>, greater <tuple <long long, long long, long long>>> pq;
    pq.push({0, 0, 1});

    while (pq.size()) {
        auto [pp, tt, u] = pq.top();
        pq.pop();

        if (v[u]) continue;
        v[u] = 1;

        t[u] = tt;
        p[u] = pp;

        for (auto [ppp, ttt, v] : edges[u]) {
            pq.push({max(pp, ppp), tt + ttt, v});
        }
    }

    cout << p[n] << ' ' << t[n] << endl;
    return 0;

}

