#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e6 + 10;
int a[MAXN];

class Fenwick{
    vector <int> segment;
public:
    Fenwick(int n) : segment(n + 1, 1e9) {}

    void update(int pos, int val) {
        while (pos < segment.size()) {
            segment[pos] += val;
            pos += (pos & (-pos));
        }
    }

};

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    unsigned int I10 = (1 << 10), I20 = (1 << 20);

    int n;
    cin >> n;

    int num;

    for (int i = 0; i < n; i++) {
        cin >> num;

        a[i / 3] <<= 10;
        a[i / 3] += num;
    }


    set <pair <int, int>> s;
    s.insert({n - 1, 0});

    int val;

    for (int i = n - 2; i >= 0; i--) {
        if (i % 3 == 0) {
            num = a[i / 3] / I20;
        } else if (i % 3 == 1) {
            num = a[i / 3] / I10 % I10;
        } else {
            num = a[i / 3] % I10;
        }

        //cout << num << endl;

        while (s.size() > 600) {
            s.erase(prev(s.end()));
        }

        if (num == 0) {
            val = 1e9;
        } else {
            //it = s.upper_bound({i + num, 1e9 + 1e7});
            val = (*prev(s.upper_bound({i + num, 1e9 + 1e7}))).second;
        }

        val++;

        while (s.size() && (*(s.begin())).second >= val) {
            s.erase(s.begin());
        }

        s.insert({i, val});

        //if (i == 0) {
            if (val >= 1e9) cout << -1 << '\n';
            else cout << val << '\n';
        //}
    }

    return 0;

}
