#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>
using namespace std;
const int MAXN=2*1e5+10;
const int INF=1e9;
vector<pair<int,int>> gp[MAXN];
vector<pair<int,int>> gw[MAXN];
bool visp[MAXN];
bool visw[MAXN];
vector<int> distp(MAXN,INF);
vector<int> distw(MAXN,INF);
int n,m;
void dijkstrap(int s){
    distp[s]=0;
    visp[s]=1;
    priority_queue<pair<int,int>,vector<pair<int,int>>, greater<pair<int,int>>> pq;
    pq.push({0,s});
    while(!pq.empty()){
        auto [x,d]=pq.top();
        pq.pop();
        visp[d]=1;
        distp[d]=x;
        for(int i=0;i<gp[d].size();i++){
            if(visp[gp[d][i].first]){
                continue;
            }
            if(distp[gp[d][i].first]>max(x,gp[d][i].second)){
                pq.push({max(x,gp[d][i].second),gp[d][i].first});
                distp[gp[d][i].first]=max(x,gp[d][i].second);
            }
        }
    }
}
void dijkstraw(int s){
    distw[s]=0;
    visw[s]=1;
    priority_queue<pair<int,int>,vector<pair<int,int>>, greater<pair<int,int>>> pq;
    pq.push({0,s});
    while(!pq.empty()){
        auto [x,d]=pq.top();
        pq.pop();
        visw[d]=1;
        distw[d]=x;
        for(int i=0;i<gw[d].size();i++){
            if(visw[gw[d][i].first]){
                continue;
            }
            if(gp[d][i].second>distp[n]){
                continue;
            }
            if(distw[gw[d][i].first]>x+gw[d][i].second){
                pq.push({x+gw[d][i].second,gw[d][i].first});
                distw[gw[d][i].first]=x+gw[d][i].second;
            }
        }
    }
}
int main(){
    cin>>n>>m;
    for(int i=1;i<=m;i++){
        int u,v,p,w;
        cin>>u>>v>>p>>w;
        gp[u].push_back({v,p});
        gp[v].push_back({u,p});
        gw[u].push_back({v,w});
        gw[v].push_back({u,w});
    }
    dijkstrap(1);
    dijkstraw(1);
    cout<<distp[n]<<" "<<distw[n]<<endl;
    return 0;
}
