#include <bits/stdc++.h>
#define pb push_back
#define int long long
#define endl '\n'
using namespace std;
template <class T> using matrix = vector <vector<T>>;
matrix <array <int, 3>> g;

const int MAXN = 2e5;

int used[MAXN + 5];
bool used1[MAXN + 5];
int mind[MAXN + 5];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    g.resize(n + 5);
    for (int i = 0; i < m; i++) {
        int x, y, p, w; cin >> x >> y >> p >> w;
        g[x].pb({y, p, w});
        g[y].pb({x, p, w});
    }
    priority_queue <array <int, 3>, vector <array <int, 3>>, greater <array<int, 3>>> pq;
    pq.push({0, 0, n});
    while (!pq.empty()) {
        auto [d, len, u] = pq.top(); pq.pop();
        if (used1[u]) continue;
        used1[u] = true;
        mind[u] = d;
        for (auto [v, p, w] : g[u]) {
            if (!used1[v]) {
                pq.push({max(d, p), len + w, v});
            }
        }
    }
    pq.push({0, 0, 1});
    int ansd = 1e18 + 1, anslen = 2e18 + 1;
    while (!pq.empty()) {
        auto [d, len, u] = pq.top(); pq.pop();
        if (u == n) {
            if (d <= ansd && len <= anslen) {
                ansd = d;
                anslen = len;
            }
        }
        used[u] = len;
        for (auto [v, p, w] : g[u]) {
            if (v == 1) continue;
            if (used[v] == 0 || (used[v] > len + w && mind[v] > max(p, d)) || v == n) {
                pq.push({max(d, p), len + w, v});
            }
        }
    }
    cout << ansd << " " << anslen << endl;
}
