#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <queue>
#define endl '\n'
using namespace std;
long long d[300005];
long long dw[300005];
int n,m;
struct edge {
    int ver;
    long long dist;
    edge(int v, long long d) {ver = v, dist = d;}
    ~edge(){}
    const bool operator<(edge a) const {
        return dist>a.dist;
    }
};
vector<edge> g[300005];
void dijkstra() {
    priority_queue<edge> q;
    q.push({1, 0});
    while(!q.empty()) {
        //cout << q.top().dist << " ";
        edge c = q.top(); q.pop();
        //if(!q.empty())cout << q.top().dist;
        //cout << endl;
        for(edge x : g[c.ver]) {
            if(d[x.ver] > max(d[c.ver],x.dist)) {
                d[x.ver] = max(d[c.ver],x.dist);
                dw[x.ver]=dw[c.ver]+1;
                x.dist = max(d[c.ver],x.dist);
                q.push(x);
            }
        }
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    cin >> n >> m;
    for(int i = 0; i < m; i++) {
        int u,v,w,p; cin >> u >> v >> p >> w;
        g[u].push_back({v, p});
        g[v].push_back({u, p});
    }
    for(int i = 2; i <= n; i++) {
        d[i]=2e9;
    }
    dijkstra();

    cout << d[n] << " " << dw[n] << endl;
}

