#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>
#include <queue>
#define endl '\n'
using namespace std;
int d[300000];
int n,m;
struct edge {
    int ver, dist;
    edge(int v, int d) {ver = v, dist = d;}
    ~edge(){}
    const bool operator<(edge a) const {
        return dist<a.dist;
    }
};
vector<edge> g[300000];
void dijkstra() {
    priority_queue<edge> q;
    q.push({1, 0});
    while(!q.empty()) {
        edge c = q.top(); q.pop();
        for(edge x : g[c.ver]) {
            if(d[x.ver] > max(d[c.ver],x.dist)) {
                d[x.ver] = max(d[c.ver],x.dist);
                x.dist = max(d[c.ver],x.dist);
                q.push(x);
            }
        }
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    cin >> n >> m;
    for(int i = 0; i < m; i++) {
        int u,v,w,p; cin >> u >> v >> p >> w;
        g[u].push_back({v, p});
    }
    for(int i = 2; i <= n; i++) {
        d[i]=2e9;
    }
    dijkstra();

    cout << d[n] << " " << 0 << endl;
}

