#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>
#define endl '\n'
#define ll long long

using namespace std;
ll n,m;
const ll MAXN=200010;
struct edge
{
    ll ver,o,g;
    edge()
    {
        ver=1;
        o=0;
        g=0;
    }
    edge(ll _ver,ll _o,ll _g)
    {
        ver=_ver;
        o=_o;
        g=_g;
    }
    bool operator<(const edge&e) const
    {
        if(o>e.o)return false;
        if(o<e.o)return true;
        return g>e.g;

    }
};
ll op[MAXN];
ll g[MAXN];
vector <edge> ve[MAXN];
void rr()
{
    ll u,v,p,w;
    cin>>u>>v>>p>>w;
    edge x(v,p,w);
    edge y(u,p,w);
    ve[v].push_back(y);
    ve[u].push_back(x);
}
const ll inf=1e9;
void read()
{
    cin>>n>>m;
    for(ll i=1;i<=m;i++)
    {
        rr();
        op[i]=inf;
        g[i]=inf;
    }
    op[1]=g[1]=0;
    /**for(ll i=1;i<=n;i++)
    {
        cout<<i<<"#";
        for(ll j=0;j<ve[i].size();j++)
        {
            cout<<"@"<<ve[i][j].ver<<" "<<ve[i][j].o<<" "<<ve[i][j].g;
        }
        cout<<endl;
    }*/
}
void deekstra()
{
    priority_queue<edge> q;
    edge w(1,0,0);
    q.push(w);
    while(!q.empty())
    {
        w=q.top();
        q.pop();
        //cout<<w.ver<<" s"<<endl;
        for(ll i=0;i<ve[w.ver].size();i++)
        {
            edge nb=ve[w.ver][i];
            //cout<<nb.ver<<" "<<nb.o<<" "<<nb.g<<endl;
            if(op[nb.ver]>max(op[w.ver],nb.o))
            {
                op[nb.ver]=max(op[w.ver],nb.o);
                g[nb.ver]=g[w.ver]+nb.g;
                edge x(nb.ver,op[nb.ver],g[nb.ver]);
                q.push(x);
            }
            else if(op[nb.ver]==max(op[w.ver],nb.o) && g[nb.ver]>g[w.ver]+nb.g)
            {
                op[nb.ver]=max(op[w.ver],nb.o);
                g[nb.ver]=g[w.ver]+nb.g;
                edge x(nb.ver,op[nb.ver],g[nb.ver]);
                q.push(x);
            }
        }
    }
}
int main()
{
    /**ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);*/
    read();
    //cout<<0<<endl;
    deekstra();
    cout<<op[n]<<" "<<g[n]<<endl;
    return 0;
}
/**
1#@2 1 1@3 2 3
2#@1 1 1@3 3 1@4 1 2@5 1 3
3#@1 2 3@2 3 1@5 1 1
4#@2 1 2@5 1 2
5#@2 1 3@3 1 1@4 1 2
*/
