#include<bits/stdc++.h>
using namespace std;

struct rebro
{
    long long to, p, w;
};

const long long MAXN = 2*1e5+7, INF = 1e18;
long long n, m, all[MAXN], dist[MAXN];
vector<rebro> adj[MAXN];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    for(long long i = 1; i <= m; i++)
    {
        long long u, v, p, w;
        cin>>u>>v>>p>>w;
        adj[u].push_back({v, p, w});
        adj[v].push_back({u, p, w});
    }
    for(int i = 1; i <= n; i++)
    {
        all[i] = INF;
    }
    priority_queue<pair<long long, long long>, vector<pair<long long, long long> >, greater<pair<long long, long long> > > pq;
    pq.push({0, 1});
    all[1] = 0;
    while(!pq.empty())
    {
        long long c1 = pq.top().first;
        long long c2 = pq.top().second;
        pq.pop();
        for(rebro next: adj[c2])
        {
            if(max(next.p, c1) < all[next.to])
            {
                all[next.to] = max(next.p, c1);
                pq.push({all[next.to], next.to});
            }
        }
    }
    for(int i = 1; i <= n; i++)
    {
        dist[i] = INF;
    }
    pq.push({0, 1});
    dist[1] = 0;
    while(!pq.empty())
    {
        long long c1 = pq.top().first;
        long long c2 = pq.top().second;
        pq.pop();
        for(rebro next: adj[c2])
        {
            if(next.p > all[n]) continue;
            if(c1+next.w < dist[next.to])
            {
                dist[next.to] = c1+next.w;
                pq.push({dist[next.to], next.to});
            }
        }
    }
    cout<<all[n]<<" "<<dist[n];
    return 0;
}

