#include<bits/stdc++.h>
using namespace std;

const int MAXN = 5*1e5+7, INF = 1e4;
int n;
int a[MAXN], dp[MAXN], seg[4*MAXN];

void update(int i, int l, int r, int q, int x)
{
    if(l > q || r < q) return;
    if(l == q && r == q)
    {
        seg[i] = x;
        return;
    }
    int mid = (l+r)/2;
    update(i*2, l, mid, q, x);
    update(i*2+1, mid+1, r, q, x);
    seg[i] = min(seg[i*2], seg[i*2+1]);
    return;
}

int query(int i, int l, int r, int ql, int qr)
{
    if(r < ql || l > qr) return INF;
    if(ql <= l && r <= qr) return seg[i];
    int mid = (l+r)/2;
    return min(query(i*2, l, mid, ql, qr), query(i*2+1, mid+1, r, ql, qr));
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i = 1; i <= n; i++)
    {
        cin>>a[i];
    }
    for(int i = 1; i < 4*n; i++)
    {
        seg[i] = INF;
    }
    dp[n] = 0;
    update(1, 1, n, n, 0);
    for(int i = n-1; i >= 1; i--)
    {
        if(a[i] > 0) dp[i] = query(1, 1, n, i+1, min(n, i+a[i]))+1;
        else dp[i] = INF;
        update(1, 1, n, i, dp[i]);
    }
    if(dp[1] >= INF) cout<<-1;
    else cout<<dp[1];
    return 0;
}
