#include <iostream>
#include <vector>
#include <queue>
using namespace std;
int n, m;
struct edge
{
    long long ver, dist, cost;
    bool operator < (const edge &e)const
    {
        if(dist < e.dist)return 1;
        if(dist > e.dist)return 0;
        return cost < e.cost;
    }
};
vector <edge> v[200005];
long long d[1024][1024];
void read()
{
    cin >> n >> m;
    int u, v1, p, w;
    for(int i = 1; i <= m; i++)
    {
        cin >> u >> v1>> p >> w;
        v[u].push_back({v1, p, w});
        v[v1].push_back({u, p, w});
        d[v1][u] = d[u][v1] = p;
    }
}
void init()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            if(d[i][j] == 0)d[i][j] = 1e9;
        }
    }
    d[1][1] = 0;
}
void solve()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            for(int k = 1; k <= n; k++)
            {
                if(i != j && i != k && j != k)
                {
                    if(d[i][j] > max(d[i][k], d[k][j]))
                    {
                        d[i][j] = max(d[i][k], d[k][j]);
                    }
                }
            }
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    init();
    solve();
    cout << d[1][n] << " " << 1 << endl;
    return 0;
}
