#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>
using namespace std;

const int MAXN=2*1e5;
const int MAXM=3*1e5;
vector<vector<pair<long long, long long>>> g(MAXN);
vector<vector<pair<long long, long long>>> g1(MAXN);
long long ans1;
long long n, m;

long long dijkstra()
{
    priority_queue<pair<long long, pair<long long,long long>>> pq;
    vector<long long> ans(n, LLONG_MAX);
    ans[0]=0;
    for(int i=0; i<g[0].size(); i++)
    {
        if(g1[0][i].second<=ans1)
        {
            pq.push({g[0][i].second, {0, g[0][i].first}});
        }
    }
    while(pq.size()!=0)
    {
        long long c=pq.top().first;
        long long x=pq.top().second.first;
        long long y=pq.top().second.second;
        pq.pop();
        if(ans[y]>ans[x]+c)
        {
            ans[y]=ans[x]+c;
            for(int i=0; i<g[y].size(); i++)
            {
                if(g1[y][i].second<=ans1)
                {
                    pq.push({g[y][i].second, {y, g[y][i].first}});
                }
            }
        }
    }
    return ans[n-1];
}

long long dijkstra1()
{
    priority_queue<pair<long long, pair<long long,long long>>> pq;
    vector<long long> ans(n, LLONG_MAX);
    ans[0]=0;
    for(int i=0; i<g1[0].size(); i++)
    {
        pq.push({g1[0][i].second, {0, g1[0][i].first}});
    }
    while(pq.size()!=0)
    {
        long long c=pq.top().first;
        long long x=pq.top().second.first;
        long long y=pq.top().second.second;
        pq.pop();
        if(ans[y]>c)
        {
            ans[y]=c;
            for(int i=0; i<g1[y].size(); i++)
            {
                pq.push({g1[y][i].second, {y, g1[y][i].first}});
            }
        }
    }
    return ans[n-1];
}

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void input()
{
    cin >> n >> m;
    for(int i=0; i<m; i++)
    {
        long long x, y, p, w;
        cin >> x >> y >> p >> w;
        x--;
        y--;
        g[x].push_back({y, w});
        g[y].push_back({x, w});
        g1[x].push_back({y, p});
        g1[y].push_back({x, p});
    }
}

void solve()
{
    ans1=dijkstra1();
    cout << ans1 << " " << dijkstra() << endl;
}

int main ()
{
    fastIO();
    input();
    solve();
    return 0;
}
