#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>
using namespace std;

const int MAXN=2*1e5;
const int MAXM=3*1e5;
vector<vector<pair<int, int>>> g(MAXN);
int n, m;

int dijkstra()
{
    priority_queue<pair<int, pair<int,int>>> pq;
    vector<int> ans(n, INT_MAX);
    ans[0]=0;
    for(int i=0; i<g[0].size(); i++)
    {
        pq.push({g[0][i].second, {0, g[0][i].first}});
    }
    while(pq.size()!=0)
    {
        int c=pq.top().first;
        int x=pq.top().second.first;
        int y=pq.top().second.second;
        pq.pop();
        if(ans[y]>ans[x]+c)
        {
            ans[y]=ans[x]+c;
            for(int i=0; i<g[y].size(); i++)
            {
                pq.push({g[y][i].second, {y, g[y][i].first}});
            }
        }
    }
    return ans[n-1];
}

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void input()
{
    cin >> n >> m;
    for(int i=0; i<m; i++)
    {
        int x, y, c, w;
        cin >> x >> y >> c >> w;
        x--;
        y--;
        g[x].push_back({y, w});
        g[y].push_back({x, w});
        //r[i]={c, {x,y}};
    }
}

void solve()
{
    cout << 1 << " " << dijkstra() << endl;
}

int main ()
{
    fastIO();
    input();
    solve();
    return 0;
}
