#include <bits/stdc++.h>
#define pb push_back
using namespace std;
template <class T> using matrix = vector <vector<T>>;
matrix <array <int, 3>> g;

const int MAXN = 2e5;

bool used[MAXN + 5];

int main() {
    int n, m; cin >> n >> m;
    g.resize(n + 1);
    for (int i = 0; i < m; i++) {
        int x, y, p, w; cin >> x >> y >> p >> w;
        g[x].pb({y, p, w});
        g[y].pb({x, p, w});
    }
    priority_queue <array <int, 3>, vector <array <int, 3>>, greater <array<int, 3>>> pq;
    pq.push({0, 0, 1});
    while (!pq.empty()) {
        auto [d, len, u] = pq.top(); pq.pop();
        if (used[u]) continue;
        if (u == n) {
            cout << d << " " << len << endl;
        }
        used[u] = true;
        for (auto [v, p, w] : g[u]) {
            if (!used[v]) {
                pq.push({max(d, p), len + w, v});
            }
        }
    }
}
