#include<bits/stdc++.h>
using namespace std;
const long long INF=1e18;
void IshowspeedNigga()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


long long dist[400'000];

vector<pair<pair<long long, long long>, long long>>graph[400'010];

long long n, m;

long long check(long long MAXX)
{

    for (long long i=1; i<=n; i++)
    {
        dist[i]=INF;
    }

    dist[1]=0;

    priority_queue<pair<long long, long long>>pq;
    pq.push({0, 1});

    while(pq.size())
    {
        long long t=-pq.top().first;
        long long curr=pq.top().second;
        pq.pop();

        if (dist[curr]<t) continue;


        for (long long i=0; i<graph[curr].size(); i++)
        {
            long long next=graph[curr][i].first.first;

            if (graph[curr][i].second<=MAXX)
            {
                if (t+graph[curr][i].first.second<dist[next])
                {
                    dist[next]=t+graph[curr][i].first.second;
                    pq.push({(-dist[next]), next});
                }
            }
        }
    }

    return dist[n];
}


int main ()
{
    IshowspeedNigga();


    cin>>n>>m;



    for (long long i=1; i<=n; i++)
    {
        dist[i]=INF;
    }
    long long mx=0;
    vector<long long>v;
    for (long long i=0; i<m; i++)
    {
        long long from, to, x, y;
        cin>>from>>to>>x>>y;

        graph[from].push_back({{to, y}, x});
        graph[to].push_back({{from, y}, x});
        v.push_back(x);
    }

    vector<long long>nw;
    sort(v.begin(), v.end());

    for (long long i=0; i<v.size(); i++)
    {
        if (v.size()-1==i || v[i]!=v[i+1]) nw.push_back(v[i]);
    }
    v=nw;


    long long l=0;
    long long r=v.size()-1;
    long long answer, answer2;
    while (l<=r)
    {
        long long mid=(l+r)/2;
        long long ans=check(v[mid]);

        if (ans==INF)
        {
            l=mid+1;
        }
        else
        {
            r=mid-1;
            answer=v[mid];
            answer2=ans;
        }
    }

    cout<<answer<<" "<<answer2<<endl;

    return 0;
}

