#include <bits/stdc++.h>
using namespace std;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int N = 2e5 + 11;
const int M = 3e5 + 11;
vector<pair<int, pair<long long,  long long>>> to[N];
pair<long long,  long long> data[N]; /// opastnost, gorivo
int n, m;
int u, v;
long long p;
 long long w;
bool vis[N];
priority_queue<pair<pair<long long, long long>, int>> pq;

void dijkstra(int start){
    pq.push({{0, 0}, start}); /// index, opastnost, gorivo
    data[start] = {0, 0};

    while(!pq.empty()){
        pair<pair< long long,  long long>, int> curr = pq.top();
    ///    cout<<curr.first<<" "<<curr.second.first<<" "<<curr.second.second<<endl;
        pq.pop();

        if(vis[curr.second])continue;
        vis[curr.second] = true;

        for(auto next : to[curr.second]){
             long long nextW = next.second.second;
            int nextInd = next.first;

            if(data[nextInd].first >= max(data[curr.second].first, next.second.first)){
             ///   cout<<data[nextInd].first <<" "<< data[curr.first].first <<" "<<next.second.first<<endl;
                if(data[nextInd].first == max(data[curr.second].first, next.second.first)){
                    data[nextInd].second = min(data[nextInd].second, ( long long)(nextW + data[curr.second].second));
                }else{
                    data[nextInd].second = nextW + data[curr.second].second;
                }
                data[nextInd].first = max(data[curr.second].first, next.second.first);
             /*   cout<<endl<<endl;
                cout<<"For Curr: "<<curr.first<<" "<<curr.second.first<<" "<<curr.second.second<<endl;
                cout<<"For Next: "<<next.first<<" "<<next.second.first<<" "<<next.second.second<<endl;
                cout<<endl;
                cout<<"Curr vruh: "<<curr.first<<endl;
                cout<<"Opastnost na vruh: "<<data[curr.first].first<<endl;
                cout<<"Gorivo na vruh: "<<data[curr.first].second<<endl;
                cout<<endl;
                cout<<"Next vruh: "<<nextInd<<endl;
                cout<<"Opastnost na vruh: "<<data[nextInd].first<<endl;
                cout<<"Gorivo na vruh: "<<data[nextInd].second<<endl;
                */
            }

            pq.push({{-data[nextInd].first, -data[nextInd].second}, nextInd});
        }
    }

  ///  cout<<endl<<endl;
}

int main(){

   /* long long nig = -1e18;
    cout<<nig<<endl; */
    fastIO();
    cin>>n>>m;
    for(int i=1; i<=m; i++){
        cin>>u>>v>>p>>w;
        to[u].push_back({v, {p, w}});
        to[v].push_back({u, {p, w}});
    }
  ///  cout<<LLONG_MAX<<endl;
    for(int i=2; i<=n; i++){
        data[i] = {LLONG_MAX, LLONG_MAX};
    }
    dijkstra(1);
    cout<<(unsigned long long)data[n].first<<" "<<(unsigned long long)data[n].second<<endl;
    return 0;
}


/*

5 7
1 2 1 1
1 3 2 3
2 3 3 1
2 4 1 2
2 5 1 3
3 5 1 1
4 5 1 2

*/

/*

4 4
1 2 1000000000000000000 5000000000000
2 4 1000000000000000000 5000000000000
1 3 1000000000000000000 5000000000000
3 4 1000000000000000000 5000000000000

*/








