#include <bits/stdc++.h>
using namespace std;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int N = 2e5 + 11;
vector<pair<int, pair<long long, long long>>> to[N];
bool vis[N];
pair<long long, long long> ans = {LLONG_MAX, LLONG_MAX};
int n, m;

void dfs(int curr, long long p, long long w){
    if(curr == n){
        if(ans.first >= p){
            ans.first = min(p, ans.first);
            ans.second = min(ans.second, w);
        }
        return;
    }
    for(auto next : to[curr]){
        if(vis[next.first]){
            continue;
        }
        vis[next.first] = true;
        dfs(next.first, max(p, next.second.first), w + next.second.second);
        vis[next.first] = false;
    }
}

int main(){
    cin>>n>>m;
    while(m --){
        int u, v, p, w;
        cin>>u>>v>>p>>w;
        to[u].push_back({v, {p, w}});
        to[v].push_back({u, {p, w}});
    }
    dfs(1, 0LL, 0LL);
    cout<<ans.first<<" "<<ans.second<<endl;
}













