#include <bits/stdc++.h>
using namespace std;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
}

struct Node{
    int l, r, minn;
};

const int N = 2e5 + 11;
const int M = 3e5 + 11;
vector<pair<int, pair<long long, long long>>> to[N];
pair<long long, long long> data[N]; /// opastnost, gorivo
int n, m, u, v, p, w;
priority_queue<pair<int, pair<long long, long long>>> pq;

void dijkstra(int start){
    pq.push({start, {-1, 0}}); /// index, opastnost, gorivo
    data[start] = {-1, 0};

    while(!pq.empty()){
        pair<int, pair<long long, long long>> curr = pq.top();
        cout<<curr.first<<" "<<curr.second.first<<" "<<curr.second.second<<endl;
        pq.pop();

        for(auto next : to[curr.first]){
            long long nextP = next.second.first;
            long long nextW = next.second.second;
            int nextInd = next.first;

            if(data[nextInd].first >= max(data[curr.first].first, -curr.second.first)){
                data[nextInd].first = max(nextP, -curr.second.first);
                data[nextInd].second = min(data[nextInd].second, nextW + curr.second.second);
            }

            pq.push({nextInd, {-nextP, nextW}});
        }
    }
}

int main(){
    fastIO();
    cin>>n>>m;
    for(int i=1; i<=m; i++){
        cin>>u>>v>>p>>w;
        to[u].push_back({v, {p, w}});
    }
    dijkstra(1);
    cout<<data[n].first<<" "<<data[n].second<<endl;
    return 0;
}

















