#include<bits/stdc++.h>
using namespace std;

struct rebro
{
    long long to, p, w;
};

const long long MAXN = 2*1e5+7;
long long n, m;
vector<rebro> adj[MAXN];
bool vis[MAXN];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    for(long long i = 1; i <= m; i++)
    {
        long long u, v, p, w;
        cin>>u>>v>>p>>w;
        adj[u].push_back({v, p, w});
        adj[v].push_back({u, p, w});
    }
    priority_queue<pair<long long, long long>, vector<pair<long long, long long> >, greater<pair<long long, long long> > > pq;
    long long allowed = 1;
    vis[1] = true;
    pq.push({0, 1});
    while(!pq.empty())
    {
        long long c1 = pq.top().first;
        long long c2 = pq.top().second;
        //cout<<c1<<" "<<c2<<" "<<allowed<<"\n";
        if(c1 > allowed) allowed = c1;
        pq.pop();
        if(c2 == n) break;
        for(rebro next: adj[c2])
        {
            if(vis[next.to]) continue;
            vis[next.to] = true;
            pq.push({next.p, next.to});
        }
    }
    cout<<allowed<<" "<<1;
    return 0;
}

