#include <iostream>
#include <queue>
using namespace std;

struct ast
{
    int v;
    unsigned long long p,w;
};
bool operator<(ast a,ast b)
{
    if(a.p>b.p)return 1;
    if(a.p<b.p)return 0;
    if(a.w>b.w)return 1;
    return 0;
}

vector<ast> g[200001];
priority_queue<ast> q;
bool used[200001];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int n,m,u,v,siz;
    unsigned long long p,w;
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        cin>>u>>v>>p>>w;
        g[u].push_back({v,p,w});
        g[v].push_back({u,p,w});
    }
    q.push({1,0,0});
    ast el;
    while(!q.empty())
    {
        el=q.top();
        q.pop();
        if(used[el.v])continue;
        if(el.v==n)break;
        used[el.v]=1;
        siz=g[el.v].size();
        for(int i=0;i<siz;i++)
        {
            if(!used[g[el.v][i].v])
            {
                q.push({g[el.v][i].v,max(el.p,g[el.v][i].p),el.w+g[el.v][i].w});
            }
        }
    }
    cout<<124414<<' '<<el.w<<'\n';

    return 0;
}
